from engine_caldav import Engine_CalDAV
from engine_gtasks import Engine_GTasks
from engine_gkeep import Engine_GKeep

class Engine:
    
    def __init__(self):
        return
    
    def get(self, id, engine, db):

        # Create engine instances
        match engine['type']:
            case 'caldav':
                return Engine_CalDAV(id, engine, db)
            case 'gtasks':
                return Engine_GTasks(id, engine, db)
            case 'gkeep':
                return Engine_GKeep(id, engine, db)
            case _:      
                raise Exception('Unknown engine type')
    