import gpsoauth

def get_gpsoauth_mastertoken(email, android_id):

    gpsoauth_exchange_instructions = '''
    You need to install gpsoauth with gpsoauth.exchange_token() support
    git clone https://github.com/kiwiz/gpsoauth
    copy gpsoauth/gpsoauth to this script dir
    '''

    master_token_instructions = '''
    Obtain the oauth_token
    Login to your Google account in anonymous mode via 
    https://accounts.google.com/EmbeddedSetup
    and obtain the value of "oauth_token" from cookies (F12 - data - cookies)
    '''

    # Check gpsoauth
    if not 'exchange_token' in dir(gpsoauth):
        raise Exception(gpsoauth_exchange_instructions)

    # Write instructions
    print(master_token_instructions)

    # Get oauth_token
    oauth_token = input('oauth_token: ').strip()

    # Get master_token
    master_response = gpsoauth.exchange_token(email, oauth_token, android_id)
    master_token = master_response['Token']

    return master_token
