from google_auth_oauthlib.flow import InstalledAppFlow
import webbrowser
import time
from multiprocessing import Process, Event, Queue
from flask import Flask, Response, render_template

def start(self):

    self.app.run()

class Google_OAuth():
    
    def __init__(self, credentials, scopes):

        app = Flask(__name__)

        self.credentials = credentials
        self.scopes = scopes      
        self.app = app
        self.event = Event()
        self.data = Queue()
       
        @app.route('/')
        def index():

            # Sign in with Google
            return render_template('sign_in_google.html')

        @app.route('/login')
        def login():

            # Get credentials
            creds = self.get_credentials()

            # Return credentials
            self.data.put(creds)

            # Set event
            self.event.set()

            return render_template('close_tab.html')

    def get_credentials(self):

        # Load credentials from JSON
        flow = InstalledAppFlow.from_client_config(self.credentials, self.scopes)

        # Initiate the OAuth2 flow
        creds = flow.run_local_server(port=35000, access_type='offline')

        return creds

    # Returns credentials
    def run(self):

        # Start server
        server = Process(target=start, args=(self,))
        server.start()

        # Wait for the start
        time.sleep(1)

        # Open in Chrome
        url = f'http://127.0.0.1:5000/'
        webbrowser.open(url, new=2) 

        # Wait for the event
        self.event.wait()

        # Wait for the response to be delivered
        time.sleep(1)

        # Terminate
        server.terminate()
        server.join()

        # Get credentials
        return self.data.get()
