import logging

from datetime import datetime
from settings import Settings

class Log:

    logger = None
    logFormatter = '%(asctime)s %(levelname)s:%(message)s'

    @classmethod
    def init(cls):

        # Logging
        logging.basicConfig(
            #   level=logging.DEBUG, # (DEBUG, INFO, WARNING, ERROR, CRITICAL)
            format=Log.logFormatter,
        )    

        # Log path
        if Settings.log_path:

            root = logging.getLogger()
            fileHandler = logging.FileHandler(datetime.today().strftime(Settings.log_path))
            loggingFormatter = logging.Formatter(Log.logFormatter)
            fileHandler.setFormatter(loggingFormatter)
            root.addHandler(fileHandler)

        # Main
        cls.logger = logging.getLogger('DataBridge')
        cls.logger.level = logging.DEBUG

        # CalDAV
        #log = logging.getLogger("caldav")
        #log.level = logging.DEBUG


    def debug(msg):
        Log.logger.debug(msg)

    def info(msg):
        Log.logger.info(msg)

    def error(msg):
        Log.logger.error(msg)
        
Log.init()
