#!/bin/python

import smtplib

from email.mime.text import MIMEText
from email.mime.multipart import MIMEMultipart

from sync import Sync
from settings import Settings,Data
from log import Log

def main():

    # Sync
    Sync()

def send_mail(exception):

    # Message
    message = MIMEMultipart("alternative")
    message["Subject"] = 'DataBridge persistent error: {}'.format(str(exception))
    message["From"] = 'DataBridge service <>'
    message["To"] = Settings.email

    # Text
    text = message["Subject"]
    part1 = MIMEText(text, "plain")
    message.attach(part1)

    # Send
    smtpObj = smtplib.SMTP('localhost')
    smtpObj.sendmail('', Settings.email, message.as_string())
   
if __name__ == "__main__":

    try:
        main()

        # Clear errors
        if Data.error_count > 0:

            # Reset            
            Data.error_count = 0
            Data.error_sent = False
            Data.save()
   
    except Exception as exc:       

        Log.error(str(exc))

        # Threshold
        if Data.error_count > Settings.error_threshold:

            if not Data.error_sent:

                # Mark
                Data.error_sent = True           
                Data.save()

                # Send
                if Settings.email:
                    send_mail(exc)

        else:

            # Inc
            Data.error_count += 1
            Data.save()

        raise exc
