import json
import os

class SettingsClass:
    
    # Get script dir
    script_dir = os.path.dirname(os.path.abspath(__file__))

    settings_file = script_dir + '/data/settings.json'
    data_file = script_dir + '/data/data.json'

    error_threshold = 5

    def __init__(self):

        try:
            # Open json
            f = open(self.settings_file)
            settings = json.load(f)
            f.close()        
        except:
            settings = {}

        # Parse settings
        self.log_path = settings['log_path'] if 'log_path' in settings else None
        self.email = settings['email'] if 'email' in settings else None
        self.error_threshold = settings['error_threshold'] if 'error_threshold' in settings else self.error_threshold
        self.engine = settings['engine']
        self.bridge = settings['bridge']

class DataClass:

    # Get script dir
    script_dir = os.path.dirname(os.path.abspath(__file__))

    data_file = script_dir + '/data/data.json'

    def __init__(self):

        try:
            # Open json
            f = open(self.data_file)
            data = json.load(f)
            f.close()        
        except:
            data = {}

        # Parse data
        self.error_count = data['error_count'] if 'error_count' in data else 0
        self.error_sent = data['error_sent'] if 'error_sent' in data else False

    def to_dict(self) -> dict:
        return {key: value for key, value in self.__dict__.items()}
          
    def save(self):

        # Return data
        data = self.to_dict()

        # Save
        with open(self.data_file, "w") as outfile:
            json.dump(data, outfile, sort_keys=True, indent=4)


Settings = SettingsClass()
Data = DataClass()